var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

export var CONTEXT_KEY = 'RockeyTheme';

var RockeyThemeProvider = function (_React$Component) {
  _inherits(RockeyThemeProvider, _React$Component);

  function RockeyThemeProvider() {
    _classCallCheck(this, RockeyThemeProvider);

    return _possibleConstructorReturn(this, (RockeyThemeProvider.__proto__ || Object.getPrototypeOf(RockeyThemeProvider)).apply(this, arguments));
  }

  _createClass(RockeyThemeProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var theme = Object.assign({}, this.context[CONTEXT_KEY], this.props.theme || {});

      return _defineProperty({}, CONTEXT_KEY, theme);
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }]);

  return RockeyThemeProvider;
}(React.Component);

RockeyThemeProvider.contextTypes = _defineProperty({}, CONTEXT_KEY, PropTypes.object);
RockeyThemeProvider.childContextTypes = _defineProperty({}, CONTEXT_KEY, PropTypes.object);
RockeyThemeProvider.propTypes = {
  theme: PropTypes.object
};


export default RockeyThemeProvider;